<template>
  <div>
    <Steps :current="current" class="tc mt-20 mb-20">
      <Step :title="$t('personticket.step1')"></Step>
      <Step :title="$t('personticket.step2')"></Step>
      <Step :title="$t('personticket.step3')"></Step>
      <Step :title="$t('personticket.step5')"></Step>
      <Step :title="$t('personticket.step4')"></Step>
    </Steps>
    <Spin fix v-show="$store.getters.getmodloading">
      <Icon type="ios-loading" size="18" class="demo-spin-icon-load"></Icon>
      <div>{{ $t('loading') }}</div>
    </Spin>
    <h1 class="mt-5 mb-30 tc">
      <Icon type="md-train" />
      {{$t('personticket.title')}}
    </h1>
    <Form label-position="top" inline>
      <Row>
        <i-Col span="24" v-if="current == 0">
          <Card dis-hover class="mt-10 gray tc">
            {{$t('trainborard.date')}}：
            <selectdate @sendout="sendoutfordate" />
            {{$t('trainborard.Arrivedfromthestation')}}：
            <selectarea @sendout="getstartarea" />
            <Icon type="md-swap" class="mr-5" />
            <selectarea @sendout="getendarea" />
            <Button
              type="primary"
              @click="train_time_board(godate,startarea,endarea)"
            >{{$t('trainborard.search')}}</Button>
          </Card>
        </i-Col>

        <i-col span="24" v-show="current == 1">
          <traintable v-if="btngroup==='0'" :tableboard="train_time" @sendout="getticketdata" />
          <h5 class="mt-10">{{ $t('trainborard.footerword1') }}</h5>
          <h5 class="mb-10">{{ $t('trainborard.footerword2') }}</h5>
        </i-col>

        <i-col span="24" v-show="current == 2">
          <table
            v-for="(it,index) in  train_price"
            :key="index+'price'"
            class="tc"
            width="100%"
            colspan="5"
          >
            <thead>
              <tr>
                <th width="50%" class="p-5">
                  <h2>{{ $t('personticket.schedule') }}</h2>
                </th>
                <th width="50%" class="p-5">
                  <h2>{{ $t('personticket.ticketprice') }}</h2>
                </th>
                <th>
                  <h2>{{ $t('personticket.selectprice') }}</h2>
                </th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td>
                  <h2 class="mt-5 mb-5">
                    {{it.OriginStationName.Zh_tw}}
                    <Icon type="md-arrow-round-forward" />
                    {{it.DestinationStationName.Zh_tw}}
                  </h2>
                </td>
                <td>
                  <h3 class="tc">
                    {{ $t('personticket.tickettype') }} :
                    <b
                      v-if="tickettype==0"
                    >{{ $t('personticket.Fullticket') }}</b>
                    <b v-if="tickettype==1">{{ $t('personticket.Halfticket') }}</b>
                    <b>${{train_price[0].Fares[tickettype].Price}}</b>
                    {{ $t('personticket.money') }}
                  </h3>
                </td>
                <td>
                  <Select
                    style="width:170px;"
                    v-model="tickettype"
                    :placeholder="$t('personticket.selecttickettype') "
                    class="pl-10 pr-10"
                  >
                    <Option
                      :key="it.Fares[0].Price"
                      :value="0"
                    >{{ $t('personticket.Fullticket') }} ${{it.Fares[0].Price}} {{ $t('personticket.money') }}</Option>
                    <Option
                      :key="it.Fares[1].Price"
                      :value="1"
                    >{{ $t('personticket.Halfticket') }} ${{it.Fares[1].Price}} {{ $t('personticket.money') }}</Option>
                  </Select>
                </td>
              </tr>
            </tbody>
          </table>
        </i-col>

        <Card dis-hover class="gray" v-show="current == 3">
          <selectseat @outseatbridge="getseat" ref="setseatfun" />
        </Card>

        <Card dis-hover class="mt-10 gray tc" v-show="current == 4">
          <h3 class="mb-20 tc">{{$t('personticket.persondata')}}</h3>
          <FormItem :label="$t('personticket.idnum')">
            <i-Input
              style="width:120px;"
              v-model="idmember"
              :placeholder="$t('personticket.plstypeid')"
            ></i-Input>
          </FormItem>
          <FormItem :label="$t('personticket.mail')">
            <i-Input
              style="width:160px;"
              v-model="email"
              :placeholder="$t('personticket.plstypemail')"
            ></i-Input>
          </FormItem>
          <FormItem :label="$t('personticket.Seatpreference')">
            <RadioGroup type="button" v-model="seattype">
              <Radio label="0">{{$t('personticket.nospecify')}}</Radio>
              <Radio label="1">{{$t('personticket.Tableseatpriority')}}</Radio>
              <Radio label="2">{{$t('personticket.Parent-childcarpriority')}}</Radio>
            </RadioGroup>
          </FormItem>
          <FormItem :label="$t('personticket.ticketcount_normal')">
            <h1>{{normalseat}} {{$t('personticket.Bit')}}</h1>
          </FormItem>
          <FormItem :label="$t('personticket.needwheelseat')">
            <CheckboxGroup>
              <InputNumber :max="6" :min="0" v-show="showseat" v-model="helpseat"></InputNumber>
              <i-switch size="large" v-model="showseat" class="ml-10">
                <span slot="close">{{$t('personticket.no')}}</span>
                <span slot="open">{{$t('personticket.yes')}}</span>
              </i-switch>
            </CheckboxGroup>
          </FormItem>
          <FormItem :label="$t('personticket.chgseat')">
            <i-switch size="large" class="ml-10" v-model="chgseat">
              <span slot="close">{{$t('personticket.no')}}</span>
              <span slot="open">{{$t('personticket.yes')}}</span>
            </i-switch>
          </FormItem>
        </Card>

        <i-col span="24" v-show="current == 4">
          <Card class="mt-10 bg goborderl" dis-hover>
            <h1 class="fr">
              <Icon type="md-train" />
              | {{ $t('personticket.Onewayticket') }}
            </h1>
            <Form label-position="top" class="mt-5" inline v-if="step2getdata!=''">
              <h1 class="mb-15">
                {{step2getdata.TrainDate}}|
                {{step2getdata.OriginStopTime.StationName.Zh_tw}}
                {{step2getdata.OriginStopTime.DepartureTime}} {{ $t('personticket.go') }} {{ $t('personticket.to') }}
                {{step2getdata.DestinationStopTime.StationName.Zh_tw}}
                {{step2getdata.DestinationStopTime.ArrivalTime}} {{ $t('personticket.arrive') }}
              </h1>
              <FormItem :label="$t('personticket.Trips')">
                <h1>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '7'  "
                  >{{ $t('components.trainborard.Shuttlebusfast') }}</font>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '6'  "
                  >{{ $t('components.trainborard.Shuttlebusfast') }}</font>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '10' "
                  >{{ $t('components.trainborard.normalfast') }}</font>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '5'  "
                  >{{ $t('components.trainborard.Shuttlebus') }}</font>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '4'  "
                  >{{ $t('components.trainborard.ChuKuang') }}</font>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '3'  "
                  >{{ $t('components.trainborard.TzeChiang') }}</font>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '2'  "
                  >{{ $t('components.trainborard.Puoma') }}</font>
                  <font
                    v-if=" step2getdata.DailyTrainInfo.TrainTypeCode === '1'  "
                  >{{ $t('components.trainborard.TarokoExpress') }}</font>
                  - ({{step2getdata.DailyTrainInfo.TrainNo}})
                </h1>
              </FormItem>
              <FormItem :label="$t('personticket.Seatpreference')">
                <h1 v-if="seattype == '0'">{{$t('personticket.nospecify')}}</h1>
                <h1 v-if="seattype == '1'">{{$t('personticket.Tableseatpriority')}}</h1>
                <h1 v-if="seattype == '2'">{{$t('personticket.Parent-childcarpriority')}}</h1>
              </FormItem>
              <FormItem :label="$t('personticket.chgseat')">
                <h1 v-if="chgseat">{{$t('personticket.yes')}}</h1>
                <h1 v-if="!chgseat">{{$t('personticket.no')}}</h1>
              </FormItem>
              <FormItem :label="$t('personticket.Generalseat')">
                <h1>{{normalseat}} {{$t('personticket.Bit')}}</h1>
              </FormItem>
              <FormItem :label="$t('personticket.Wheelchairseat')" v-show="showseat">
                <h1 v-show="showseat">{{helpseat}} {{$t('personticket.Bit')}}</h1>
              </FormItem>
              <FormItem :label="$t('personticket.idnum')">
                <h1 v-if="idmember==''" style="color:red;">{{$t('personticket.Notfilled')}}</h1>
                <h1>{{idmember}}</h1>
              </FormItem>
              <FormItem :label="$t('personticket.tickettype')" v-if="train_price!=''">
                <h1 class="tc">
                  <b v-if="tickettype==0">{{$t('personticket.Fullticket')}}</b>
                  <b v-if="tickettype==1">{{$t('personticket.Halfticket')}}</b>
                </h1>
              </FormItem>
              <FormItem :label="$t('personticket.seat')">
                <span v-for="(it4,index) in seatobj" :key="index+'seat'">
                  <h2 class="fl m-10 p-5">
                    {{$t('personticket.non')}}
                    <b>{{it4.seat}}</b>
                    {{$t('personticket.Bit')}}
                  </h2>
                </span>
              </FormItem>
              <FormItem :label="$t('personticket.ticketprice')" v-if="train_price!=''">
                <h1 class="tc">
                  <b>${{(normalseat+helpseat)*(train_price[0].Fares[tickettype].Price)}}</b>
                  {{$t('personticket.money')}}
                </h1>
              </FormItem>
            </Form>
          </Card>
        </i-col>

        <i-col span="24" class="tc mt-20 mb-20">
          <Button
            v-show="current > '0'"
            type="primary"
            @click="restep()"
          >{{ $t('personticket.back') }}</Button>
          <Button
            v-show="current == '1'"
            type="primary"
            @click="step2()"
          >{{ $t('personticket.next') }}</Button>
          <Button
            v-show="current == '2'"
            type="primary"
            @click="next()"
          >{{ $t('personticket.next') }}</Button>
          <Button
            v-show="current  == '3'"
            type="primary"
            @click="step3()"
          >{{ $t('personticket.next') }}</Button>
          <Button
            v-show="current == '4'"
            type="error"
            @click="sendticket()"
          >{{ $t('personticket.ticketit') }}</Button>
        </i-col>

        <Divider />
      </Row>
    </Form>
  </div>
</template>

<script>
import { mapMutations } from "vuex";
import moment from "moment";
import firebase from "firebase/app";
import traintable from "~/components/ticketpage/ticketingtable.vue";
import selectdate from "~/components/tools/selectdate.vue";
import selectarea from "~/components/tools/selectstation.vue";
import selectseat from "~/components/ticketpage/selectseat.vue";
export default {
  components: {
    traintable,
    selectdate,
    selectarea,
    selectseat
  },
  data() {
    return {
      idmember: "",
      email: "",
      btngroup: "0",
      startarea: "",
      endarea: "",
      selctnote: "",
      godate: null,
      train_time: [],
      current: 0,
      showseat: false,
      talkmodal: false,
      selectgoback: false,
      chgseat: false,
      seattype: "0",
      helpseat: 0,
      normalseat: 0,
      step2getdata: [],
      train_price: [],
      tickettype: 0,
      selectprice: [],
      acount: [],
      seatobj: []
    };
  },
  mounted() {
    this.acount = JSON.parse(localStorage.getItem("logindata"));
  },
  watch: {
    tickettype(val) {
      const selectprice = this.train_price[0].Fares[val];
    },
    showseat(bool) {
      if (bool) {
        return (this.talkmodal = !this.talkmodal), (this.helpseat = 1);
      }
      if (!bool) {
        return (this.helpseat = 0);
      }
    }
  },
  methods: {
    ...mapMutations({
      toggleloading: "toggleloading"
    }),
    sendoutfordate(childValue) {
      this.godate = childValue;
    },
    getstartarea(sendoutarea) {
      this.startarea = sendoutarea;
    },
    getendarea(sendoutarea) {
      this.endarea = sendoutarea;
    },
    getticketdata(getticketdata) {
      this.step2getdata = getticketdata;
    },
    //檢查此搜尋班次是否有已訂座位
    async checkseat() {
      const db = firebase.firestore();
      const ref = db
        .collection("trainseat")
        .where("trainno", "==", this.step2getdata.DailyTrainInfo.TrainNo) //車號
        .where("date", "==", this.step2getdata.TrainDate) //日期
        .where("starttime", "==", this.step2getdata.OriginStopTime.DepartureTime) //時間
      await ref
        .get()
        .then(data => {
          if (data.empty) {
            //如果沒有直接給0初始化座位表
            this.$refs.setseatfun.sethasseat(0)
          } else {
            const setseat = [];
            //如果有取出陣列送至座位表Fun去過濾座位
            data.forEach(doc => {
              const seat = doc.data();
              setseat.push(seat)
            });
            this.$refs.setseatfun.sethasseat(setseat)
          }
        })
    },
    //上一步
    restep() {
      this.current -= 1;
    },
    //下一步
    next() {
      if (this.current == 4) {
        this.current = 0;
      } else {
        this.current += 1;
      }
    },
    //第二步選擇班次
    step2() {
      if (this.acount == null) {
        this.$Message.error(this.$t("trainborard.fun_ticketit"));
      } else {
        if (this.step2getdata.length != 0) {
          this.next();
          const startarea = this.step2getdata.OriginStopTime.StationID;
          const endarea = this.step2getdata.DestinationStopTime.StationID;
          this.gettrain_price(startarea, endarea); //抓取班次之間價錢
          this.checkseat(); // 執行檢查訂票座位
        } else {
          this.$Message.error(this.$t("personticket.selectseat"));
        }
      }
    },
    //第四步選擇座位
    step3() {
      if (this.seatobj == "") {
        this.$Message.error((this.$t("personticket.step3fun")));
      } else {
        this.next();
      }
    },
    //搜尋座位班次
    async train_time_board(date, startarea, endarea) {
      this.toggleloading();
      if (date != null && startarea != "" && endarea != "") {
        if (startarea === endarea) {
          this.$Message.error(
            this.$t("trainborard.fun_train_time_board_Message")
          );
          this.toggleloading();
        } else {
          const train_time = await this.$axios.$get(
            `DailyTimetable/OD/${startarea}/to/${endarea}/${date}?$top=50&$format=JSON`
          );
          this.train_time = train_time;
          this.next();
          this.toggleloading();
          if (train_time.length == 0) {
            this.$Message.warning(
              this.$t("trainborard.fun_train_time_board_Message_2")
            );
            this.current = 0;
          }
        }
      } else {
        this.$Message.error(
          this.$t("trainborard.fun_train_time_board_Message_3")
        );
        this.toggleloading();
      }
    },
    //抓取班次之間價錢
    async gettrain_price(startarea, endarea) {
      this.toggleloading();
      const train_price = await this.$axios.$get(
        `ODFare/${startarea}/to/${endarea}?$top=30&$format=JSON`
      );
      this.train_price = train_price;
      this.toggleloading();
    },
    getseat(val) {
      this.seatobj = val;
      this.normalseat = val.length;
    },
    //送出車位座表
    async sendtrainseat() {
      const userid = this.acount.user.uid;
      const senddata = {
        /*日期*/ date: this.step2getdata.TrainDate,
        /*會員ID*/ uid: this.acount.user.uid,
        /*車次*/ trainno: this.step2getdata.DailyTrainInfo.TrainNo,
        /*車種*/ traintype: this.step2getdata.DailyTrainInfo.TrainTypeCode,
        /*座位 */ seatobj: this.seatobj,
        /*購票時間*/ buydate: moment(Date.now()).format("LLLL"),
        /*開始時間*/ starttime: this.step2getdata.OriginStopTime.DepartureTime,
        /*結束時間*/ endtime: this.step2getdata.DestinationStopTime.ArrivalTime
      };
      const db = firebase.firestore();
      const ref = db.collection("trainseat");
      await ref.add(senddata).then(data => {
        console.log(`success`,data);
      });
    },
    //送出車位訂票
    async sendticket() {
      const countticket = this.helpseat + this.normalseat;
      const setdata = {
        /*票卷狀態*/ backtcket: "0",
        /*會員ID*/ uid: this.acount.user.uid,
        /*身分證字號*/ idnum: this.idmember,
        /*mail*/ mail: this.email,

        /*座位喜好*/ seatlike: this.seattype,
        /*車次*/ trainno: this.step2getdata.DailyTrainInfo.TrainNo,
        /*車種*/ traintype: this.step2getdata.DailyTrainInfo.TrainTypeCode,

        /*票種*/ tickettype: this.tickettype,
        /*票價*/ ticketprice: this.train_price,
        /*總票數*/ ticketnum: countticket,
        /*可否換位*/ chgseat: this.chgseat,
        /*需要輪椅位*/ whweelseat: this.showseat,
        /*輪椅座位*/ whweelseatnum: this.helpseat,
        /*一般座位*/ seatnum: this.normalseat,

        /*日期*/ date: this.step2getdata.TrainDate,
        /*開始時間*/ starttime: this.step2getdata.OriginStopTime.DepartureTime,
        /*結束時間*/ endtime: this.step2getdata.DestinationStopTime.ArrivalTime,
        /*起站*/ startarea: this.step2getdata.OriginStopTime.StationName.Zh_tw,
        /*抵站*/ endarea: this.step2getdata.DestinationStopTime.StationName.Zh_tw,
        /*座位 */ seatobj: this.seatobj,
        /*購票時間*/ buydate: moment(Date.now()).format("LLLL")
      };
      if (this.idmember == "" || this.email == "") {
        this.$Message.error(this.$t("personticket.plscheckform"));
      } else {
        this.toggleloading();
        await firebase;
        const db = firebase.firestore();
        const ref = db.collection("ticket");
        await ref
          .add(setdata)
          .then(data => {
            this.sendtrainseat();
            this.$Message.success(this.$t("personticket.yesticket"));
            location.reload();
          })
          .catch(error => {
            this.$Message.error(this.$t("personticket.happenerror"));
          });
        this.toggleloading();
        // location.reload();
      }
    }
  }
};
</script>
